Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/TRD/trdtrc.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/TRD/trdtrc.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/TRD/trdtrc.F90	(revision 14219)
@@ -13,5 +13,5 @@
       INTEGER ::   kt, kjn, ktrd   
       INTEGER ::   Kmm            ! time level index
-      REAL(wp)::   ptrtrd(:,:,:)  
+      REAL(dp)::   ptrtrd(:,:,:)  
       WRITE(*,*) 'trd_trc : You should not have seen this print! error?', ptrtrd(1,1,1)
       WRITE(*,*) '  "      "      : You should not have seen this print! error?', kjn, ktrd, kt
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/TRD/trdvor.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/TRD/trdvor.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/TRD/trdvor.F90	(revision 14219)
@@ -49,7 +49,7 @@
    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   vor_avrbn    ! after vorticity at time step after the
    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   rotot        ! begining of the NN_WRITE-1 timesteps
-   REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   vor_avrtot   !
-   REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   vor_avrres   !
-   REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   vortrd       ! curl of trends
+   REAL(dp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   vor_avrtot   !
+   REAL(dp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   vor_avrres   !
+   REAL(dp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   vortrd       ! curl of trends
          
    CHARACTER(len=12) ::   cvort
@@ -86,5 +86,5 @@
       !!               and make outputs (NetCDF format)
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   putrd, pvtrd   ! U and V trends 
+      REAL(dp), DIMENSION(:,:,:), INTENT(inout) ::   putrd, pvtrd   ! U and V trends 
       INTEGER                   , INTENT(in   ) ::   ktrd           ! trend index
       INTEGER                   , INTENT(in   ) ::   kt             ! time step
@@ -237,6 +237,6 @@
       INTEGER                         , INTENT(in   ) ::   ktrd       ! ocean trend index
       INTEGER                         , INTENT(in   ) ::   Kmm        ! time level index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   putrdvor   ! u vorticity trend 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pvtrdvor   ! v vorticity trend
+      REAL(dp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   putrdvor   ! u vorticity trend 
+      REAL(dp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pvtrdvor   ! v vorticity trend
       !
       INTEGER ::   ji, jj, jk   ! dummy loop indices
@@ -400,5 +400,6 @@
 
          ! Boundary conditions
-         CALL lbc_lnk_multi( 'trdvor', vor_avrtot, 'F', 1.0_wp , vor_avrres, 'F', 1.0_wp )
+         CALL lbc_lnk_multi( 'trdvor', vor_avrtot, 'F', 1.0_wp &
+              &                      , vor_avrres, 'F', 1.0_wp )
 
 
@@ -458,5 +459,7 @@
       !!      from ocean surface down to control surface (NetCDF output)
       !!----------------------------------------------------------------------
-      REAL(wp) ::   zjulian, zsto, zout
+      REAL(dp)  :: zjulian
+      REAL(dp)  :: zsto
+      REAL(dp) :: zout
       CHARACTER (len=40) ::   clhstnam
       CHARACTER (len=40) ::   clop
@@ -574,2 +577,3 @@
    !!======================================================================
 END MODULE trdvor
+
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_hgr.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_hgr.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_hgr.F90	(revision 14219)
@@ -59,10 +59,20 @@
       !!              - define u- & v-surfaces (if gridsize reduction is used in some straits) (in m2)
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:), INTENT(out) ::   plamt, plamu, plamv, plamf   ! longitude outputs                     [degrees]
-      REAL(wp), DIMENSION(:,:), INTENT(out) ::   pphit, pphiu, pphiv, pphif   ! latitude outputs                      [degrees]
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: plamt
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: plamf
+      REAL(wp), DIMENSION(:,:), INTENT(out) :: plamu, plamv   ! longitude outputs                     [degrees]
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pphit
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pphif
+      REAL(wp), DIMENSION(:,:), INTENT(out) :: pphiu, pphiv   ! latitude outputs                      [degrees]
       INTEGER                 , INTENT(out) ::   kff                          ! =1 Coriolis parameter computed here, =0 otherwise
       REAL(wp), DIMENSION(:,:), INTENT(out) ::   pff_f, pff_t                 ! Coriolis factor at f-point                [1/s]
-      REAL(wp), DIMENSION(:,:), INTENT(out) ::   pe1t, pe1u, pe1v, pe1f       ! i-scale factors                             [m]
-      REAL(wp), DIMENSION(:,:), INTENT(out) ::   pe2t, pe2u, pe2v, pe2f       ! j-scale factors                             [m]
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pe1t
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pe1u
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pe1f
+      REAL(wp), DIMENSION(:,:), INTENT(out) :: pe1v       ! i-scale factors                             [m]
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pe2t
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pe2v
+      REAL(dp), DIMENSION(:,:), INTENT(out)  :: pe2f
+      REAL(wp), DIMENSION(:,:), INTENT(out) :: pe2u       ! j-scale factors                             [m]
       INTEGER                 , INTENT(out) ::   ke1e2u_v                     ! =1 u- & v-surfaces computed here, =0 otherwise 
       REAL(wp), DIMENSION(:,:), INTENT(out) ::   pe1e2u, pe1e2v               ! u- & v-surfaces (if reduction in strait)   [m2]
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_istate.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_istate.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_istate.F90	(revision 14219)
@@ -47,7 +47,7 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   pdept   ! depth of t-point               [m]
       REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   ptmask  ! t-point ocean mask             [m]
-      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(  out) ::   pts     ! T & S fields      [Celsius ; g/kg]
-      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   pu      ! i-component of the velocity  [m/s] 
-      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   pv      ! j-component of the velocity  [m/s] 
+      REAL(dp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(  out) ::   pts     ! T & S fields      [Celsius ; g/kg]
+      REAL(dp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   pu      ! i-component of the velocity  [m/s] 
+      REAL(dp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   pv      ! j-component of the velocity  [m/s] 
       !
       INTEGER :: ji, jj, jk  ! dummy loop indices
@@ -90,5 +90,5 @@
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(in   ) ::   ptmask  ! t-point ocean mask   [m]
-      REAL(wp), DIMENSION(jpi,jpj)         , INTENT(  out) ::   pssh    ! sea-surface height   [m]
+      REAL(dp), DIMENSION(jpi,jpj)         , INTENT(  out) ::   pssh    ! sea-surface height   [m]
       !!----------------------------------------------------------------------
       !
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_zgr.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_zgr.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/USR/usrdef_zgr.F90	(revision 14219)
@@ -53,5 +53,6 @@
       REAL(wp), DIMENSION(:)    , INTENT(out) ::   pe3t_1d , pe3w_1d           ! 1D grid-point depth     [m]
       REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pdept, pdepw                ! grid-point depth        [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pe3t , pe3u , pe3v , pe3f   ! vertical scale factors  [m]
+      REAL(dp), DIMENSION(:,:,:), INTENT(out) ::   pe3t                        ! vertical scale factors  [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::          pe3u , pe3v , pe3f   ! vertical scale factors  [m]
       REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pe3w , pe3uw, pe3vw         ! i-scale factors 
       INTEGER , DIMENSION(:,:)  , INTENT(out) ::   k_top, k_bot                ! first & last ocean level
@@ -221,5 +222,6 @@
       REAL(wp), DIMENSION(:)    , INTENT(in   ) ::   pe3t_1d , pe3w_1d           ! 1D vertical scale factors [m]
       REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pdept, pdepw                ! grid-point depth          [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3t , pe3u , pe3v , pe3f   ! vertical scale factors    [m]
+      REAL(dp), DIMENSION(:,:,:), INTENT(  out) ::   pe3t                        ! vertical scale factors    [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::          pe3u , pe3v , pe3f   ! vertical scale factors    [m]
       REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3w , pe3uw, pe3vw         !    -       -      -
       !
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfdrg.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfdrg.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfdrg.F90	(revision 14219)
@@ -76,4 +76,5 @@
 #  include "do_loop_substitute.h90"
 #  include "domzgr_substitute.h90"
+#  include "single_precision_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -157,6 +158,6 @@
       INTEGER                         , INTENT(in   ) ::   kt         ! ocean time-step index
       INTEGER                         , INTENT(in   ) ::   Kmm        ! time level indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pub, pvb   ! the two components of the before velocity
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pua, pva   ! the two components of the velocity tendency
+      REAL(dp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pub, pvb   ! the two components of the before velocity
+      REAL(dp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pua, pva   ! the two components of the velocity tendency
       !! 
       INTEGER  ::   ji, jj       ! dummy loop indexes
@@ -164,5 +165,5 @@
       REAL(wp) ::   zm1_2dt      ! local scalar
       REAL(wp) ::   zCdu, zCdv   !   -      -
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdu, ztrdv
+      REAL(dp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdu, ztrdv
       !!---------------------------------------------------------------------
       !
@@ -209,6 +210,6 @@
       ENDIF
       !                                          ! print mean trends (used for debugging)
-      IF(sn_cfctl%l_prtctl)   CALL prt_ctl( tab3d_1=pua, clinfo1=' bfr  - Ua: ', mask1=umask,               &
-         &                                  tab3d_2=pva, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
+      IF(sn_cfctl%l_prtctl)   CALL prt_ctl( tab3d_1=CASTWP(pua), clinfo1=' bfr  - Ua: ', mask1=umask,               &
+         &                                  tab3d_2=CASTWP(pva), clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
    END SUBROUTINE zdf_drg_exp
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfmfc.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfmfc.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfmfc.F90	(revision 14219)
@@ -59,4 +59,5 @@
 #  include "do_loop_substitute.h90"
 #  include "domzgr_substitute.h90"
+#  include "single_precision_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.2 , NEMO Consortium (2018)
@@ -95,5 +96,5 @@
       !!----------------------------------------------------------------------
       INTEGER                                  , INTENT(in)    :: Kmm, Krhs ! time level indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts,jpt), INTENT(inout) :: pts       ! active tracers and RHS of tracer equation
+      REAL(dp), DIMENSION(jpi,jpj,jpk,jpts,jpt), INTENT(inout) :: pts       ! active tracers and RHS of tracer equation
       REAL(wp), DIMENSION(jpi,jpj,jpk,2) ::   ztsp         ! T/S of the plume
       REAL(wp), DIMENSION(jpi,jpj,jpk,2) ::   ztse         ! T/S at W point
@@ -106,5 +107,6 @@
       REAL(wp), DIMENSION(jpi,jpj) :: zustar, zustar2   !
       REAL(wp), DIMENSION(jpi,jpj) :: zuws, zvws, zsws, zfnet          !
-      REAL(wp), DIMENSION(jpi,jpj) :: zfbuo, zrautbm1, zrautb, zraupl
+      REAL(wp), DIMENSION(jpi,jpj) :: zfbuo, zrautbm1
+      REAL(dp), DIMENSION(jpi,jpj) :: zrautb, zraupl
       REAL(wp), DIMENSION(jpi,jpj) :: zwpsurf            !
       REAL(wp), DIMENSION(jpi,jpj) :: zop0 , zsp0 !
@@ -208,6 +210,6 @@
          ! Compute the buoyancy acceleration on T-points at jk-1
          zrautbm1(:,:) = zrautb(:,:)
-         CALL eos( pts (:,:,jk  ,:,Kmm) ,  zrautb(:,:)   )
-         CALL eos( ztsp(:,:,jk-1,:    ) ,  zraupl(:,:)   )
+         CALL eos( CASTWP(pts (:,:,jk  ,:,Kmm)) ,  zrautb(:,:)   )
+         CALL eos( CASTWP(ztsp(:,:,jk-1,:    )) ,  zraupl(:,:)   )
 
          zphm1(:,:)  = zphm1(:,:)  + grav * zrautbm1(:,:) * e3t(:,:,jk-1, Kmm)
@@ -376,5 +378,5 @@
       !
       !
-      CALL lbc_lnk_multi( 'zdfmfc', edmfm,'T',1., edmfa,'T',1., edmfb,'T',1., edmfc,'T',1., edmftra(:,:,:,jp_tem),'T',1., edmftra(:,:,:,jp_sal),'T',1.)
+      CALL lbc_lnk_multi( 'zdfmfc', edmfm,'T',1._wp, edmfa,'T',1._wp, edmfb,'T',1._wp, edmfc,'T',1._wp, edmftra(:,:,:,jp_tem),'T',1._wp, edmftra(:,:,:,jp_sal),'T',1._wp)
       !
    END SUBROUTINE tra_mfc
@@ -383,5 +385,5 @@
    SUBROUTINE diag_mfc( zdiagi, zdiagd, zdiags, p2dt, Kaa )
 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::  zdiagi, zdiagd, zdiags  ! inout: tridaig. terms 
+      REAL(dp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::  zdiagi, zdiagd, zdiags  ! inout: tridaig. terms 
       REAL(wp)                        , INTENT(in   ) ::   p2dt                   ! tracer time-step
       INTEGER                         , INTENT(in   ) ::   Kaa                    ! ocean time level indices
@@ -399,5 +401,5 @@
    SUBROUTINE rhs_mfc( zrhs, jjn )
 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   zrhs                   ! inout: rhs trend 
+      REAL(dp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   zrhs                   ! inout: rhs trend 
       INTEGER                         , INTENT(in   ) ::   jjn                    ! tracer indices
 
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfosm.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfosm.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdfosm.F90	(revision 14219)
@@ -150,4 +150,5 @@
 #  include "do_loop_substitute.h90"
 #  include "domzgr_substitute.h90"
+#  include "single_precision_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -1176,5 +1177,5 @@
        END_3D
         ! Lateral boundary conditions on final outputs for hbl,  on T-grid (sign unchanged)
-        CALL lbc_lnk_multi( 'zdfosm', hbl, 'T', 1., dh, 'T', 1., hmle, 'T', 1. )
+        CALL lbc_lnk_multi( 'zdfosm', hbl, 'T', 1._wp, dh, 'T', 1._wp, hmle, 'T', 1._wp )
         ! Lateral boundary conditions on final outputs for gham[ts],  on W-grid  (sign unchanged)
         ! Lateral boundary conditions on final outputs for gham[uv],  on [UV]-grid  (sign changed)
@@ -2752,6 +2753,6 @@
      IF( lwp ) WRITE(numout,*) ' ===>>>> : calculating hbl computed from stratification'
      ! w-level of the mixing and mixed layers
-     CALL eos_rab( ts(:,:,:,:,Kmm), rab_n, Kmm )
-     CALL bn2(ts(:,:,:,:,Kmm), rab_n, rn2, Kmm)
+     CALL eos_rab( CASTWP(ts(:,:,:,:,Kmm)), rab_n, Kmm )
+     CALL bn2(CASTWP(ts(:,:,:,:,Kmm)), rab_n, rn2, Kmm)
      imld_rst(:,:)  = nlb10         ! Initialization to the number of w ocean point
      hbl(:,:)  = 0._wp              ! here hbl used as a dummy variable, integrating vertically N^2
@@ -2795,5 +2796,5 @@
       INTEGER                                  , INTENT(in)    :: kt        ! time step index
       INTEGER                                  , INTENT(in)    :: Kmm, Krhs ! time level indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts,jpt), INTENT(inout) :: pts       ! active tracers and RHS of tracer equation
+      REAL(dp), DIMENSION(jpi,jpj,jpk,jpts,jpt), INTENT(inout) :: pts       ! active tracers and RHS of tracer equation
       !
       INTEGER :: ji, jj, jk
@@ -2832,6 +2833,6 @@
 
       IF(sn_cfctl%l_prtctl) THEN
-         CALL prt_ctl( tab3d_1=pts(:,:,:,jp_tem,Krhs), clinfo1=' osm  - Ta: ', mask1=tmask,   &
-         &             tab3d_2=pts(:,:,:,jp_sal,Krhs), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         CALL prt_ctl( tab3d_1=CASTWP(pts(:,:,:,jp_tem,Krhs)), clinfo1=' osm  - Ta: ', mask1=tmask,   &
+         &             tab3d_2=CASTWP(pts(:,:,:,jp_sal,Krhs)), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       ENDIF
       !
@@ -2867,5 +2868,5 @@
       INTEGER                             , INTENT( in )  ::  kt          ! ocean time step index
       INTEGER                             , INTENT( in )  ::  Kmm, Krhs   ! ocean time level indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk,jpt), INTENT(inout) ::  puu, pvv    ! ocean velocities and RHS of momentum equation
+      REAL(dp), DIMENSION(jpi,jpj,jpk,jpt), INTENT(inout) ::  puu, pvv    ! ocean velocities and RHS of momentum equation
       !
       INTEGER :: ji, jj, jk   ! dummy loop indices
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdftke.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdftke.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/ZDF/zdftke.F90	(revision 14219)
@@ -307,5 +307,5 @@
                   zWlc2(ji,jj) = 0.5_wp * z1_norm * ( MAX( ut0sd(ji,jj)*ztaui + vt0sd(ji,jj)*ztauj, 0._wp ) )**2
             END_2D
-         CALL lbc_lnk      ( 'zdftke', zWlc2, 'T', 1. )
+         CALL lbc_lnk      ( 'zdftke', zWlc2, 'T', 1._wp )
 !
          ELSE                          ! Surface Stokes drift deduced from surface stress
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/lib_fortran.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/lib_fortran.F90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/lib_fortran.F90	(revision 14219)
@@ -37,8 +37,10 @@
 
    INTERFACE glob_sum
-      MODULE PROCEDURE glob_sum_1d, glob_sum_2d, glob_sum_3d
+      MODULE PROCEDURE glob_sum_1d_sp, glob_sum_2d_sp, glob_sum_3d_sp
+      MODULE PROCEDURE glob_sum_1d_dp, glob_sum_2d_dp, glob_sum_3d_dp
    END INTERFACE
    INTERFACE glob_sum_full
-      MODULE PROCEDURE glob_sum_full_2d, glob_sum_full_3d
+      MODULE PROCEDURE glob_sum_full_2d_sp, glob_sum_full_3d_sp
+      MODULE PROCEDURE glob_sum_full_2d_dp, glob_sum_full_3d_dp
    END INTERFACE
    INTERFACE local_sum
@@ -49,8 +51,10 @@
    END INTERFACE
    INTERFACE glob_min
-      MODULE PROCEDURE glob_min_2d, glob_min_3d
+      MODULE PROCEDURE glob_min_2d_sp, glob_min_3d_sp
+      MODULE PROCEDURE glob_min_2d_dp, glob_min_3d_dp
    END INTERFACE
    INTERFACE glob_max
-      MODULE PROCEDURE glob_max_2d, glob_max_3d
+      MODULE PROCEDURE glob_max_2d_sp, glob_max_3d_sp
+      MODULE PROCEDURE glob_max_2d_dp, glob_max_3d_dp
    END INTERFACE
 
@@ -74,66 +78,128 @@
 #  define GLOBSUM_CODE
 
-#     define DIM_1d
-#     define FUNCTION_GLOBSUM           glob_sum_1d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBSUM
-#     undef DIM_1d
-
-#     define DIM_2d
-#     define OPERATION_GLOBSUM
-#     define FUNCTION_GLOBSUM           glob_sum_2d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBSUM
-#     undef OPERATION_GLOBSUM
-#     define OPERATION_FULL_GLOBSUM
-#     define FUNCTION_GLOBSUM           glob_sum_full_2d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBSUM
-#     undef OPERATION_FULL_GLOBSUM
-#     undef DIM_2d
-
-#     define DIM_3d
-#     define OPERATION_GLOBSUM
-#     define FUNCTION_GLOBSUM           glob_sum_3d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBSUM
-#     undef OPERATION_GLOBSUM
-#     define OPERATION_FULL_GLOBSUM
-#     define FUNCTION_GLOBSUM           glob_sum_full_3d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBSUM
-#     undef OPERATION_FULL_GLOBSUM
-#     undef DIM_3d
+#     define SINGLE_PRECISION
+#        define DIM_1d
+#        define FUNCTION_GLOBSUM           glob_sum_1d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef DIM_1d
+
+#        define DIM_2d
+#        define OPERATION_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_2d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_GLOBSUM
+#        define OPERATION_FULL_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_full_2d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_FULL_GLOBSUM
+#        undef DIM_2d
+
+#        define DIM_3d
+#        define OPERATION_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_3d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_GLOBSUM
+#        define OPERATION_FULL_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_full_3d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_FULL_GLOBSUM
+#        undef DIM_3d
+#     undef SINGLE_PRECISION
+! Double Precision versions
+#        define DIM_1d
+#        define FUNCTION_GLOBSUM           glob_sum_1d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef DIM_1d
+
+#        define DIM_2d
+#        define OPERATION_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_2d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_GLOBSUM
+#        define OPERATION_FULL_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_full_2d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_FULL_GLOBSUM
+#        undef DIM_2d
+
+#        define DIM_3d
+#        define OPERATION_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_3d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_GLOBSUM
+#        define OPERATION_FULL_GLOBSUM
+#        define FUNCTION_GLOBSUM           glob_sum_full_3d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBSUM
+#        undef OPERATION_FULL_GLOBSUM
+#        undef DIM_3d
 
 #  undef GLOBSUM_CODE
 
-
+! Single Precision versions
 #  define GLOBMINMAX_CODE
 
-#     define DIM_2d
-#     define OPERATION_GLOBMIN
-#     define FUNCTION_GLOBMINMAX           glob_min_2d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBMINMAX
-#     undef OPERATION_GLOBMIN
-#     define OPERATION_GLOBMAX
-#     define FUNCTION_GLOBMINMAX           glob_max_2d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBMINMAX
-#     undef OPERATION_GLOBMAX
-#     undef DIM_2d
-
-#     define DIM_3d
-#     define OPERATION_GLOBMIN
-#     define FUNCTION_GLOBMINMAX           glob_min_3d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBMINMAX
-#     undef OPERATION_GLOBMIN
-#     define OPERATION_GLOBMAX
-#     define FUNCTION_GLOBMINMAX           glob_max_3d
-#     include "lib_fortran_generic.h90"
-#     undef FUNCTION_GLOBMINMAX
-#     undef OPERATION_GLOBMAX
-#     undef DIM_3d
+#     define SINGLE_PRECISION
+#        define DIM_2d
+#        define OPERATION_GLOBMIN
+#        define FUNCTION_GLOBMINMAX           glob_min_2d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMIN
+#        define OPERATION_GLOBMAX
+#        define FUNCTION_GLOBMINMAX           glob_max_2d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMAX
+#        undef DIM_2d
+
+#        define DIM_3d
+#        define OPERATION_GLOBMIN
+#        define FUNCTION_GLOBMINMAX           glob_min_3d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMIN
+#        define OPERATION_GLOBMAX
+#        define FUNCTION_GLOBMINMAX           glob_max_3d_sp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMAX
+#        undef DIM_3d
+#     undef SINGLE_PRECISION
+! Double Precision versions
+#        define DIM_2d
+#        define OPERATION_GLOBMIN
+#        define FUNCTION_GLOBMINMAX           glob_min_2d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMIN
+#        define OPERATION_GLOBMAX
+#        define FUNCTION_GLOBMINMAX           glob_max_2d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMAX
+#        undef DIM_2d
+
+#        define DIM_3d
+#        define OPERATION_GLOBMIN
+#        define FUNCTION_GLOBMINMAX           glob_min_3d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMIN
+#        define OPERATION_GLOBMAX
+#        define FUNCTION_GLOBMINMAX           glob_max_3d_dp
+#        include "lib_fortran_generic.h90"
+#        undef FUNCTION_GLOBMINMAX
+#        undef OPERATION_GLOBMAX
+#        undef DIM_3d
 #  undef GLOBMINMAX_CODE
 
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/lib_fortran_generic.h90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/lib_fortran_generic.h90	(revision 14218)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/lib_fortran_generic.h90	(revision 14219)
@@ -1,6 +1,12 @@
+#if defined SINGLE_PRECISION
+#   define TYPE                          REAL(sp)
+#else
+#   define TYPE                          REAL(dp)
+#endif
+
 #if defined GLOBSUM_CODE
 !                          ! FUNCTION FUNCTION_GLOBSUM !
 #   if defined DIM_1d
-#      define ARRAY_TYPE(i,j,k)    REAL(wp)                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
+#      define ARRAY_TYPE(i,j,k)    TYPE                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
 #      define ARRAY_IN(i,j,k)   ptab(i)
 #      define ARRAY2_IN(i,j,k)  ptab2(i)
@@ -10,5 +16,5 @@
 #   endif
 #   if defined DIM_2d
-#      define ARRAY_TYPE(i,j,k)    REAL(wp)                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
+#      define ARRAY_TYPE(i,j,k)    TYPE                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
 #      define ARRAY_IN(i,j,k)   ptab(i,j)
 #      define ARRAY2_IN(i,j,k)  ptab2(i,j)
@@ -17,5 +23,5 @@
 #   endif
 #   if defined DIM_3d
-#      define ARRAY_TYPE(i,j,k)    REAL(wp)                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
+#      define ARRAY_TYPE(i,j,k)    TYPE                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
 #      define ARRAY_IN(i,j,k)   ptab(i,j,k)
 #      define ARRAY2_IN(i,j,k)  ptab2(i,j,k)
@@ -34,12 +40,10 @@
       CHARACTER(len=*),  INTENT(in   ) ::   cdname  ! name of the calling subroutine
       ARRAY_TYPE(:,:,:)                             ! array on which operation is applied
-      REAL(wp)   ::  FUNCTION_GLOBSUM
+      TYPE   ::  FUNCTION_GLOBSUM
       !
       !!-----------------------------------------------------------------------
-      !
-      REAL(wp)                              ::   FUNCTION_GLOB_OP   ! global sum
       !!
       COMPLEX(dp)::   ctmp
-      REAL(wp)   ::   ztmp
+      TYPE   ::   ztmp
       INTEGER    ::   ji, jj, jk   ! dummy loop indices
       INTEGER    ::   ipi, ipj, ipk    ! dimensions
@@ -65,4 +69,5 @@
    END FUNCTION FUNCTION_GLOBSUM
 
+#undef TYPE
 #undef ARRAY_TYPE
 #undef ARRAY2_TYPE
@@ -77,5 +82,5 @@
 !                          ! FUNCTION FUNCTION_GLOBMINMAX !
 #   if defined DIM_2d
-#      define ARRAY_TYPE(i,j,k)    REAL(wp)                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
+#      define ARRAY_TYPE(i,j,k)    TYPE                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
 #      define ARRAY_IN(i,j,k)   ptab(i,j)
 #      define ARRAY2_IN(i,j,k)  ptab2(i,j)
@@ -83,5 +88,5 @@
 #   endif
 #   if defined DIM_3d
-#      define ARRAY_TYPE(i,j,k)    REAL(wp)                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
+#      define ARRAY_TYPE(i,j,k)    TYPE                 , INTENT(in   ) ::   ARRAY_IN(i,j,k)
 #      define ARRAY_IN(i,j,k)   ptab(i,j,k)
 #      define ARRAY2_IN(i,j,k)  ptab2(i,j,k)
@@ -103,9 +108,8 @@
       CHARACTER(len=*),  INTENT(in   ) ::   cdname  ! name of the calling subroutine
       ARRAY_TYPE(:,:,:)                             ! array on which operation is applied
-      REAL(wp)   ::  FUNCTION_GLOBMINMAX
+      TYPE   ::  FUNCTION_GLOBMINMAX
       !
       !!-----------------------------------------------------------------------
       !
-      REAL(wp)                              ::   FUNCTION_GLOB_OP   ! global sum
       !!
       COMPLEX(dp)::   ctmp
@@ -129,4 +133,5 @@
    END FUNCTION FUNCTION_GLOBMINMAX
 
+#undef TYPE
 #undef ARRAY_TYPE
 #undef ARRAY2_TYPE
